/************************************************************************ *********
 * Proiectarea cu Microprocesoare
 * Laboratorul 1
 * Digital I/O
 *********************************************************************************/

#include <avr\io.h>
#include <avr\interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>

#include <string.h>

int period = 150;

void left_on(int index) { PORTA |= (1 << index); }
void left_off(int index) { PORTA &= ~(1 << index); }

void right_on(int index) {
	if (index >= 0 && index <= 1) PORTA |= (1 << (index + 6));
	else if (index == 4) PORTC |= (1 << 5);
	else if (index == 5) PORTC |= (1 << 4);
	else if (index == 2) PORTC |= (1 << 7);
	else if (index == 3) PORTC |= (1 << 6);
}
void right_off(int index) {
	if (index >= 0 && index <= 1) PORTA &= ~(1 << (index + 6));
	else if (index == 4) PORTC &= ~(1 << 5);
	else if (index == 5) PORTC &= ~(1 << 4);
	else if (index == 2) PORTC &= ~(1 << 7);
	else if (index == 3) PORTC &= ~(1 << 6);
}
void left_off_all() { int i; for (i = 0; i < 6; i++) left_off(i); }
void right_off_all() { int i; for (i = 0; i < 6; i++) right_off(i); }

void display_lights(int type) {
	int end = 0, i = 0, j = 0, k = 0, l = 1;

	while (end  == 0) {
	
		switch (type) {
			case 0:
				right_on(i);
				left_on(i);
				
				i += l;
				if (i == 5 || i == 0) {
					l *= -1;
					
					j++;
					
					if(j >= 10) {
						end = 1;
					}
				}
				break;
				
			case 1:
				for (k = 0; k <= i; k++) {
					right_on(k);
					left_on(k);
				}
				
				i++;
				if (i >= 6) {
					i = 0;
					j++;
					
					if(j >= 10) {
						end = 1;
					}
				}
				break;
				
			case 2:
				right_on(i);
				left_on(i);
				
				right_on(6 - i);
				left_on(6 - i);
				
				i++;
				if (i >= 6) {
					i = 0;
					j++;
					
					if(j >= 10) {
						end = 1;
					}
				}
				break;
				
			case 3:
				for (k = 0; k < 6; k++) {
					if (k % 2 == l) {
						right_on(k);
						left_on(k);
					}
				}
				
				if (l == 0) l = 1;
				else l = 0;
				
				i++;
				if (i >= 6) {
					i = 0;
					j++;
					
					if(j >= 10) {
						end = 1;
					}
				}
				break;
				
			case 4:
				for (k = 0; k < 6; k++) {
					if (k != i) {
						right_on(k);
						left_on(k);
					}
				}
				
				i++;
				if (i >= 6) {
					i = 0;
					j++;
					
					if(j >= 10) {
						end = 1;
					}
				}
				break;
				
			case 5:
				for (k = 0; k < 3; k++) {
					l = i + k;
					if (l >= 6) l -= 6;

					right_on(l);
					left_on(l);
				}
				
				i++;
				if (i >= 6) {
					i = 0;
					j++;
					
					if(j >= 10) {
						end = 1;
					}
				}
				break;
		}
		
		//PORTD |= (1 << PD7);
		
		_delay_ms(period / 2);
		
		PORTD &= ~(1 << PD7);
		
		_delay_ms(period / 2);
		
		left_off_all();
		right_off_all();
		
	}
}

int main() {
	int type_count = 6;
	int type = 0;

	DDRD |= (1 << PD7);
	DDRA = 0xFF;
	DDRC = 0xFF;
	
	while (1) {
		display_lights(type);
		type++;
		
		if(type == type_count) type = 0;
	}
	
	return 0;
}
